// DirectMusic Performance[h(Legacy)

#pragma once

#include <Windows.h>
#include "Constants.h"
#include "Interface.h"
#include "Smf.h"
#include <dxmus.core/Controller.h>

namespace GuruGuruSmf { namespace Core { namespace DirectMusicPerformance {

	/// <summary>
	/// DirectMusic Performance[h̃vC[
	/// </summary>
	class Player : public IPlayer
	{
	private:
		bool isOpen;

	public:
		Player();	// RXgN^
		~Player();	// fXgN^

		//
		// ISmfPlayer
		//
		
		// foCXJ
		GGSERROR OpenDevice(int deviceId, HWND handle);
		
		// foCX
		void CloseDevice();
		
		// tI
		GGSERROR Play(ISmfController* smfCtrl, int option, int seek, int fadeInTime, int keyShift);
		
		// ~I
		void Stop(int fadeOutTime);
		
		// ꎞ~
		void Pause(){ GuruGuruSmf::Dxmus::Controller::GetInstance()->PerformancePause(); }
		
		// ꎞ~
		void Restart(){ GuruGuruSmf::Dxmus::Controller::GetInstance()->PerformanceRestart(); }
		
		// tԂ擾
		void GetStatus(PlayerStatus* status){ GuruGuruSmf::Dxmus::Controller::GetInstance()->PerformanceGetStatus(status); }
		
		// }X^[e|
		void SetMasterTempo(float tempo){ GuruGuruSmf::Dxmus::Controller::GetInstance()->PerformanceSetMasterTempo(tempo); }
		
		// }X^[{[
		void SetMasterVolume(int volume){ GuruGuruSmf::Dxmus::Controller::GetInstance()->PerformanceSetMasterVolume(volume); }
		
		// }X^[sb`
		void SetMasterPitch(int pitch){}
		
	};




}}}
